% Code provided by Shuang Lu and Dr. Joseph Picone Permission is granted for anyone to copy, 
% use, modify, or distribute this program and accompanying programs and documents for any purpose,
% provided this copyright notice is retained and prominently displayed, along with a note saying 
% that the original programs are available from our web page. The programs and documents are 
% distributed without any warranty, express or implied.  As the programs were written for research
% purposes only, they have not been tested to the degree that would be advisable in any important 
% application.  All use of these programs is entirely at the user's own risk.

function varargout = Fingerspelling_Reco_Demo(varargin)

% Last Modified by GUIDE v2.5 30-Aug-2013 14:46:56

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Fingerspelling_Reco_Demo_OpeningFcn, ...
                   'gui_OutputFcn',  @Fingerspelling_Reco_Demo_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Fingerspelling_Reco_Demo is made visible.
function Fingerspelling_Reco_Demo_OpeningFcn(hObject, eventdata, handles, varargin)

% Choose default command line output for Fingerspelling_Reco_Demo
handles.output = hObject;

% Create video object
% Putting the object into manual trigger mode and then
% starting the object will make GETSNAPSHOT return faster
% since the connection to the camera will already have
% been established.
axes(handles.axes37);% Axis used for background image
 set(handles.axes37, 'Visible', 'off');
 axis off;
 set(gca,'ytick',[],'xtick',[]);% Remove tickmarks and labels that are inserted when using IMAGE
 bckgrnd = imread('Picture1.png');% Reads in the image used for the background
 bckgrnd = imresize(bckgrnd,[642,1024]);% Resizes the image to fit the dimensions of axes 37
 imshow(bckgrnd);% Displays the background image
handles.video = videoinput('winvideo',1,'YUY2_640x480');% Specifies which camera and the display size to be used
% Create the image object in which you want to
% display the video preview data.
set(handles.video,'ReturnedColorSpace','rgb');% Changes the color space to be that of red, green, and blue
set(handles.video,'TimerPeriod', 0.05, ... % Updates the video input every 0.05 seconds
'TimerFcn',['if(~isempty(gco)),'...
'handles=guidata(gcf);'... % Update handles
'c_frame = getsnapshot(handles.video);image(c_frame(50:300,50:300,:));'... % Get picture using GETSNAPSHOT and put it into axes using IMAGE
'set(handles.cameraAxes,''ytick'',[],''xtick'',[]),'... % Remove tickmarks and labels that are inserted when using IMAGE
'else '...
'delete(imaqfind);'... % Clean up - delete any image acquisition objects
'end']);
axes(handles.cameraAxes);
triggerconfig(handles.video,'manual');
handles.video.FramesPerTrigger = Inf; % Capture frames until we manually stop it
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Fingerspelling_Reco_Demo wait for user response (see UIRESUME)
uiwait(handles.Fingerspelling_Reco_Demo);
%set(handles.startStopCamera,'String','Stop Camera')


% --- Outputs from this function are returned to the command line.
function varargout = Fingerspelling_Reco_Demo_OutputFcn(hObject, eventdata, handles) 

% Get default command line output from handles structure
handles.output = hObject;
varargout{1} = handles.output;


% --- Executes on button press in startStopCamera.
function startStopCamera_Callback(hObject, eventdata, handles)
% Start/Stop Camera
if strcmp(get(handles.startStopCamera,'String'),'Start Camera')% Starts the camera by string comparison of "Start Camera" button
set(handles.startStopCamera,'String','Stop Camera')% After camera starts switches the "Start Camera" button to "Stop Camera"
axes(handles.cameraAxes);% Selects which axis to execute on
start(handles.video)% Starts camera
%set(handles.startAcquisition,'Enable','on');
set(handles.captureImage,'Enable','on');
else
% Camera is on. Stop camera and change button string.
set(handles.startStopCamera,'String','Start Camera')
stop(handles.video)
%set(handles.startAcquisition,'Enable','off');
set(handles.captureImage,'Enable','off');
end

% --- Executes on button press in captureImage.
function captureImage_Callback(hObject, eventdata, handles)
frame = get(get(handles.cameraAxes,'children'),'cdata'); % Get the current displayed frame
frame1=imresize(frame,[100,85]);% resize cropped image to match training data
imwrite(frame1,'test.png'); % save test image
disp('Frame saved to file ''testframe.mat''');
set(handles.startStopCamera,'String','Start Camera')
stop(handles.video)% stop video display

% extract HOG feature
addpath('tools/speechfileformats');% load HTK write toolbox for feature writing
addpath('tools/bin.win32');% load HTK toolbox for HVite
asl_feature_v00('test.png');

% run decoding. Recognition step
run('.\decode.m')

% load result text file
result=textread('showresult.txt','%s');
best_num=5;% define how many top results to display. 
%%%%%%%%%%%%%%%%%display result labels and images%%%%%%%%%%%%%%%%%%%
j=0;
for i = 1:length(result)        
              if ((length(result{i})==1)&&(result{i}(1)~='0'))
               j=j+1;
                label(j)=result{i}(:) ;% Fills "label" with the top five matching letters  
       end
end

sum=zeros(5,1);
j=1;
for i = 1:length(result)        
              if (result{i}(1)=='-')
                sum(j)=sum(j)+str2num(result{i}(2:length(result{i})));   %Sums up the log likelihoods for each of the top fivve choices
              end
              if (result{i}(1)=='///')
                  j=j+1;
              end
end
min_sum=sum(1);
for i = 1:5
    bar(i)= 100*(1 - abs(5*((min_sum - sum(i))/(min_sum))));% Creates a ratio out of 100 for top five choices
end

%Display results
 label_img=imread(['images/' label(1) '.png']);% Loads the image for top choice
 axes(handles.axes7);% Selects axis to execute on
 set(handles.axes7, 'Visible', 'off');
 axis off;
 set(gca,'ytick',[],'xtick',[]);% Remove tickmarks and labels that are inserted when using IMAGE
 imshow(label_img);% Displays image match for the gesture
 
 label_img=imread(['images/' label(2) '.png']);% Loads the image for alternative choice
 axes(handles.axes8);% Selects axis to execute on
 set(handles.axes8, 'Visible', 'off');
 axis off;
 set(gca,'ytick',[],'xtick',[]);% Remove tickmarks and labels that are inserted when using IMAGE
 imshow(label_img);% Displays image match for the gesture

 label_img=imread(['images/' label(3) '.png']);% Loads the image for alternative choice
 axes(handles.axes9);% Selects axis to execute on
 set(handles.axes9, 'Visible', 'off');
 axis off;
 set(gca,'ytick',[],'xtick',[]);% Remove tickmarks and labels that are inserted when using IMAGE
 imshow(label_img);% Displays image match for the gesture
 
 label_img=imread(['images/' label(4) '.png']);% Loads the image for alternative choice
 axes(handles.axes10);% Selects axis to execute on
 set(handles.axes10, 'Visible', 'off');
 axis off;
 set(gca,'ytick',[],'xtick',[]);% Remove tickmarks and labels that are inserted when using IMAGE
 imshow(label_img);% Displays image match for the gesture

 label_img=imread(['images/' label(5) '.png']);% Loads the image for alternative choice
 axes(handles.axes11);% Selects axis to execute on
 set(handles.axes11, 'Visible', 'off');
 axis off;
 set(gca,'ytick',[],'xtick',[]);% Remove tickmarks and labels that are inserted when using IMAGE
 imshow(label_img);% Displays image match for the gesture
 
 cbar = imread('colorbar.png');% Reads in the color-bar image
 
 axes(handles.axes14);% Selects axis to execute on
 set(handles.axes14, 'Visible', 'off');% Removes axis labels and marks
 bar1 = cbar;% Specify a colorbar for this choice
 bar1(35:97,(5*round(bar(1))-1):5*(round(bar(1))+2),:)= 0;% Blackens out a segment on the color-bar respective to the value of the total log likeliehood
 clrbar1 = imrotate(bar1,90);% Rotate the colorbar to be veritcal
 clrbar1 = imresize(clrbar1,[200,40]);% Resizes the color-bar tofit the axis and be more visible
 imshow(clrbar1);% Display color-bar
 
 axes(handles.axes15);% Selects axis to execute on
 set(handles.axes15, 'Visible', 'off');% Removes axis labels and marks
 bar2 = cbar;% Specify a colorbar for this choice
 bar2(35:97,(5*round(bar(2))-1):5*(round(bar(2))+2),:)= 0;% Blackens out a segment on the color-bar respective to the value of the total log likeliehood
 clrbar2 = imrotate(bar2,90);% Rotate the colorbar to be veritcal
 clrbar2 = imresize(clrbar2,[95,35]);% Resizes the color-bar tofit the axis and be more visible
 imshow(clrbar2);% Display color-bar
 
 axes(handles.axes16);% Selects axis to execute on
 set(handles.axes16, 'Visible', 'off');% Removes axis labels and marks
 bar3 = cbar;% Specify a colorbar for this choice
 bar3(35:97,(5*round(bar(3))-1):5*(round(bar(3))+2),:)= 0;% Blackens out a segment on the color-bar respective to the value of the total log likeliehood
 clrbar3 = imrotate(bar3,90);% Rotate the colorbar to be veritcal
 clrbar3 = imresize(clrbar3,[95,35]);% Resizes the color-bar tofit the axis and be more visible
 imshow(clrbar3);% Display color-bar
 
 axes(handles.axes17);% Selects axis to execute on
 set(handles.axes17, 'Visible', 'off');% Removes axis labels and marks
 bar4 = cbar;% Specify a colorbar for this choice
 bar4(35:97,(5*round(bar(4))-1):5*(round(bar(4))+2),:)= 0;% Blackens out a segment on the color-bar respective to the value of the total log likeliehood
 clrbar4 = imrotate(bar4,90);% Rotate the colorbar to be veritcal
 clrbar4 = imresize(clrbar4,[95,35]);% Resizes the color-bar tofit the axis and be more visible
 imshow(clrbar4);% Display color-bar
 
 axes(handles.axes18);% Selects axis to execute on
 set(handles.axes18, 'Visible', 'off');% Removes axis labels and marks
 bar5 = cbar;% Specify a colorbar for this choice
 bar5(35:97,(5*round(bar(5))-1):5*(round(bar(5))+2),:)= 0;% Blackens out a segment on the color-bar respective to the value of the total log likeliehood
 clrbar5 = imrotate(bar5,90);% Rotate the colorbar to be veritcal
 clrbar5 = imresize(clrbar5,[95,35]);% Resizes the color-bar tofit the axis and be more visible
 imshow(clrbar5);% Display color-bar
 
 axes(handles.axes19);% Selects axis to execute on
 axis off;
 set(gca,'ytick',[],'xtick',[]);% Removes axis labels and marks
 I = display_segments();% Loads "I" with the segmented image
 imshow(I);% Displays the segmented image
 
 axes(handles.axes20);% Selects axis to execute on
 axis off;
 set(gca,'ytick',[],'xtick',[]);% Removes axis labels and marks
 imshow(frame1)% Dislapays the original image

% --- Executes when user attempts to close Fingerspelling_Reco_Demo.
function Fingerspelling_Reco_Demo_CloseRequestFcn(hObject, eventdata, handles)

delete(hObject);
delete(imaqfind);




% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit1_Callback(hObject, eventdata, handles)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit2_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)


% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)

% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit5_Callback(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)



% --- Executes during object creation, after setting all properties.
function edit5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)

% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit9_Callback(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)


% --- Executes during object creation, after setting all properties.
function edit9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit10_Callback(hObject, eventdata, handles)
% hObject    handle to edit10 (see GCBO)


% --- Executes during object creation, after setting all properties.
function edit10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit10 (see GCBO)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
